#include <iostream>

using namespace std;

int maksi(int a[], int n)
{
    int maksi=0;
    for(int i=1; i<n; i++)
        if(maksi<a[i])
            maksi=i;
    return maksi;
}

int main()
{
    int n, q;
    cin >> n;
    int x[n], y[n], pb[n];
    for(int i=0; i<n-1; i++){
        cin >> x[i] >> y[i];
    }
    for(int i=0; i<n; i++){
        cin >> pb[i];
    }
    cin >> q;
    int z[q], b[q];
    for(int i=0; i<q; i++){
        cin >> z[i] >> b[i];
    }

    if(q==0){
        cout << maksi(pb,n)+1;
    }

    return 0;
}